//
//  AccessViewController.m
//  IOS Learning Plaform
//
//  Created by Rubén Domínguez Falcón on 18/09/13.
//  Copyright (c) 2013 TheAgileMonkeys. All rights reserved.
//

#import "AccessViewController.h"
#import "Lesson.h"

@interface AccessViewController ()

@end

@implementation AccessViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    [[CourseManager sharedInstance] configureCourse];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(dismissModals) name:@"TutorialDidEnd" object:nil];
    
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    if ([[CourseManager sharedInstance] isUserSigned]){
        if ([Lesson hasLessonsAvaliable]){
                UITabBarController *rootVC = [self.storyboard instantiateViewControllerWithIdentifier:@"TabbarViewController"];
                rootVC.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;

                [self presentViewController:rootVC animated:YES completion:nil];
        }
        
        else{
            if(![[CourseManager sharedInstance] isTestFinished]){
                UINavigationController *testVC = [self.storyboard instantiateViewControllerWithIdentifier:@"testNC"];
                testVC.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
                [self presentViewController:testVC animated:YES completion:nil];
            }
            else{
                
                UITabBarController *rootVC = [self.storyboard instantiateViewControllerWithIdentifier:@"TabbarViewController"];
                
                NSMutableArray *tbViewControllers = [NSMutableArray arrayWithArray:[rootVC viewControllers]];
                [tbViewControllers removeObjectAtIndex:0];
                [tbViewControllers removeObjectAtIndex:2];
                [rootVC setViewControllers:tbViewControllers];
                rootVC.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
                [self presentViewController:rootVC animated:YES completion:nil];
            }
            
        }
    }
    else{
        //take the registration way
        [self performSegueWithIdentifier:@"AccessVC-MotivationAdviceVC" sender:self];
    }
}

- (void)dismissModals
{
    [self dismissViewControllerAnimated:YES completion:nil];
}
@end
