//
//  AppDelegate.m
//  IOS Learning Plaform
//
//  Created by Rubén Domínguez Falcón on 18/09/13.
//  Copyright (c) 2013 TheAgileMonkeys. All rights reserved.
//

#import "AppDelegate.h"
#import <Parse/Parse.h>
#import "Crittercism.h"
@implementation AppDelegate

@synthesize managedObjectContext = _managedObjectContext;
@synthesize managedObjectModel = _managedObjectModel;
@synthesize persistentStoreCoordinator = _persistentStoreCoordinator;

#define AppDelegate (AppDelegate *)[[UIApplication sharedApplication] delegate]

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    [Parse initializeWithConfiguration:[ParseClientConfiguration configurationWithBlock:^(id<ParseMutableClientConfiguration> configuration) {
        configuration.applicationId = @"zsrtKCMyvJVmiCKeAFfEKHpLKICAlUfb1DU29KgQ";
        configuration.clientKey = @"di0ydmL9kfRAA0dcTHzB8QLM7315hYhzbu2uvMr0";
        configuration.server = @"https://stormy-plateau-29823.herokuapp.com/parse";
    }]];
    [PFAnalytics trackAppOpenedWithLaunchOptions:launchOptions];
    
    //navigation ans status Bar features
    // status Bar white
    [[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleLightContent];
    
    //navigation Bar colors
    [[UINavigationBar appearance] setBarTintColor:navbarBackground];
    [[UINavigationBar appearance] setTitleTextAttributes:@{NSForegroundColorAttributeName : [UIColor whiteColor]}];
    [[UINavigationBar appearance] setTintColor:[UIColor whiteColor]];
    
    //Local Notifications
    // Set icon badge number to zero
    UIUserNotificationType types = UIUserNotificationTypeBadge |
    UIUserNotificationTypeSound | UIUserNotificationTypeAlert;
    UIUserNotificationSettings *settings = [UIUserNotificationSettings settingsForTypes:types categories:nil];
    [[UIApplication sharedApplication] registerUserNotificationSettings:settings];
    application.applicationIconBadgeNumber = 0;
    
    if(![[NSUserDefaults standardUserDefaults] valueForKey:@"isfirstTime"]){
        
        [[UIApplication sharedApplication] cancelAllLocalNotifications];
        [[NSUserDefaults standardUserDefaults] setBool:YES forKey:@"isfirstTime"];
    }
    
    UILocalNotification *localNotif =
    [launchOptions objectForKey:UIApplicationLaunchOptionsLocalNotificationKey];
    
    if (localNotif)
    {
    
        NSLog(@"Recieved Notification %@",localNotif);
    }
    
    //Parse analytics
    [PFAnalytics trackAppOpenedWithLaunchOptions:launchOptions];
    if ([[NSUserDefaults standardUserDefaults] valueForKey:@"isUserRegistered"]){
        NSString *strDate = [NSDateFormatter localizedStringFromDate:[NSDate date]
                                                           dateStyle:NSDateFormatterMediumStyle
                                                           timeStyle:NSDateFormatterMediumStyle];
        NSDictionary *dimensions = @{
                                     @"action": @"Enter App",
                                     @"userMail": [[NSUserDefaults standardUserDefaults] valueForKey:@"userMail"],
                                     @"userId": [[NSUserDefaults standardUserDefaults] valueForKey:@"userId"],
                                     @"date": strDate
                                     };
        // Send the dimensions to Parse along with the 'search' event
        [PFAnalytics trackEvent:@"UserActivity" dimensions:dimensions];
    }
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    // Request to reload  data
    [[NSNotificationCenter defaultCenter] postNotificationName:@"reloadData" object:self];
    // Set icon badge number to zero
    application.applicationIconBadgeNumber = 0;
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    // Request to reload  data
    [[NSNotificationCenter defaultCenter] postNotificationName:@"reloadData" object:self];
    // Set icon badge number to zero
    application.applicationIconBadgeNumber = 0;
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    if ([[NSUserDefaults standardUserDefaults] valueForKey:@"isUserRegistered"]){
        NSString *strDate = [NSDateFormatter localizedStringFromDate:[NSDate date]
                                                           dateStyle:NSDateFormatterMediumStyle
                                                           timeStyle:NSDateFormatterMediumStyle];
        NSDictionary *dimensions = @{
                                 @"action": @"Leave App",
                                 @"userMail": [[NSUserDefaults standardUserDefaults] valueForKey:@"userMail"],
                                 @"userId": [[NSUserDefaults standardUserDefaults] valueForKey:@"userId"],
                                 @"date": strDate
                                 };
        // Send the dimensions to Parse along with the 'search' event
        [PFAnalytics trackEvent:@"UserActivity" dimensions:dimensions];
    }
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

- (void)saveContext
{
    NSError *error = nil;
    NSManagedObjectContext *managedObjectContext = self.managedObjectContext;
    if (managedObjectContext != nil) {
        if ([managedObjectContext hasChanges] && ![managedObjectContext save:&error]) {
            // Replace this implementation with code to handle the error appropriately.
            // abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
            NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
            abort();
        }
    }
}

#pragma mark - Core Data stack

// Returns the managed object context for the application.
// If the context doesn't already exist, it is created and bound to the persistent store coordinator for the application.
- (NSManagedObjectContext *)managedObjectContext
{
    if (_managedObjectContext != nil) {
        return _managedObjectContext;
    }
    
    NSPersistentStoreCoordinator *coordinator = [self persistentStoreCoordinator];
    if (coordinator != nil) {
        _managedObjectContext = [[NSManagedObjectContext alloc] init];
        [_managedObjectContext setPersistentStoreCoordinator:coordinator];
    }
    return _managedObjectContext;
}

// Returns the managed object model for the application.
// If the model doesn't already exist, it is created from the application's model.
- (NSManagedObjectModel *)managedObjectModel
{
    if (_managedObjectModel != nil) {
        return _managedObjectModel;
    }
    NSURL *modelURL = [[NSBundle mainBundle] URLForResource:@"DataBaseModel" withExtension:@"momd"];
    _managedObjectModel = [[NSManagedObjectModel alloc] initWithContentsOfURL:modelURL];
    return _managedObjectModel;
}

// Returns the persistent store coordinator for the application.
// If the coordinator doesn't already exist, it is created and the application's store added to it.
- (NSPersistentStoreCoordinator *)persistentStoreCoordinator
{
    if (_persistentStoreCoordinator != nil) {
        return _persistentStoreCoordinator;
    }
    
    NSURL *storeURL = [[self applicationDocumentsDirectory] URLByAppendingPathComponent:@"DataBaseModel.sqlite"];
    
    NSError *error = nil;
    _persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel:[self managedObjectModel]];
    if (![_persistentStoreCoordinator addPersistentStoreWithType:NSSQLiteStoreType configuration:nil URL:storeURL options:nil error:&error]) {
              NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
        abort();
    }
    
    return _persistentStoreCoordinator;
}

#pragma mark - Application's Documents directory

// Returns the URL to the application's Documents directory.
- (NSURL *)applicationDocumentsDirectory
{
    
    NSLog(@"%@",[[[NSFileManager defaultManager] URLsForDirectory:NSDocumentDirectory  inDomains:NSUserDomainMask] lastObject]);

    return [[[NSFileManager defaultManager] URLsForDirectory:NSDocumentDirectory inDomains:NSUserDomainMask] lastObject];
}

#pragma mark notifications delegate methods
//aplication in foreground
- (void)application:(UIApplication *)application didReceiveLocalNotification:(UILocalNotification *)notification
{
    UIApplicationState state = [application applicationState];
    if (state == UIApplicationStateBackground) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@""
                                                        message:notification.alertBody
                                                       delegate:self cancelButtonTitle:@"OK"
                                              otherButtonTitles:nil];
        [alert show];
    }
    
    // Request to reload  data
    [[NSNotificationCenter defaultCenter] postNotificationName:@"reloadData" object:self];
    // Set icon badge number to zero
    application.applicationIconBadgeNumber = 0;
}




@end
