//
//  EditTodoViewController.m
//  IOS Learning Plaform
//
//  Created by Rubén Domínguez on 23/10/13.
//  Copyright (c) 2013 TheAgileMonkeys. All rights reserved.
//

#import "EditTodoViewController.h"
#import <Parse/Parse.h>


@interface EditTodoViewController ()

@property (weak, nonatomic) IBOutlet UITextView *toDoBodyTextView;
@property (nonatomic, strong) PFObject *current_user;

@end

@implementation EditTodoViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.toDoBodyTextView.textContainer.lineFragmentPadding = 0;
    self.toDoBodyTextView.textContainerInset = UIEdgeInsetsMake(0, 0, 0, 0);
    
    if(self.object){
        self.title =  NSLocalizedString(@"editTodoPageTitle", nil);
        
    }
    else{
        self.title = NSLocalizedString(@"newtodoPageTitle", nil);
    }
    NSString *key = [[NSUserDefaults standardUserDefaults] valueForKey:@"userId"];
    PFQuery *query = [PFQuery queryWithClassName:@"Profile"];
    [query getObjectInBackgroundWithId:key block:^(PFObject *profile, NSError *error){
        if (!error) {
            self.current_user = profile;
            if(self.object) self.toDoBodyTextView.text = self.object.body;
            UIBarButtonItem *rightBarButtonItem = [[UIBarButtonItem alloc]initWithTitle:NSLocalizedString(@"doneBarButton", nil) style:UIBarButtonItemStyleDone  target:self action:@selector(doneButton)];
            self.navigationItem.rightBarButtonItem = rightBarButtonItem;
            
        }
        else{
            UIAlertView *errorAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                                 message:NSLocalizedString(@"NetworkError", nil)
                                                                delegate:nil
                                                       cancelButtonTitle:@"OK"
                                                       otherButtonTitles:nil];
            [errorAlert show];
        }
        
    }];
    
    
}

-(void) viewDidAppear:(BOOL)animated{
    [self.toDoBodyTextView becomeFirstResponder];
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark button actions
- (void) doneButton {
    
    PFObject *todo = [PFObject objectWithClassName:@"Todo_Analytics"];
    if (self.toDoBodyTextView.text && self.toDoBodyTextView.text.length > 0){
        if(self.object == nil){
            NSEntityDescription *entityDescriptor = [NSEntityDescription entityForName:@"ToDo" inManagedObjectContext:self.moc];
            self.object = [[ToDo alloc] initWithEntity:entityDescriptor insertIntoManagedObjectContext:self.moc];
        }
        
        if (self.object.parseId) {
            todo.objectId = self.object.parseId;
        }
        
        [self.object setBody:self.toDoBodyTextView.text];
        [self.object setDone:@NO];
        [self.object setDate:[NSDate dateWithTimeIntervalSinceNow:0]];
        
        todo[@"user"] = self.current_user;
        todo[@"todo"] = self.toDoBodyTextView.text;
        todo[@"date"] = [NSDate dateWithTimeIntervalSinceNow:0];
        todo[@"done"] = @NO;
        
        [todo saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
            if (!error) {
                [self.object setParseId:[todo objectId]];
                [self.moc save:nil];
                [self.navigationController popViewControllerAnimated:YES];
            }
            else{
                UIAlertView *errorAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                                     message:NSLocalizedString(@"NetworkError", nil)
                                                                    delegate:nil
                                                           cancelButtonTitle:@"OK"
                                                           otherButtonTitles:nil];
                [errorAlert show];
            }
        }];
    }
    else{
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                        message:NSLocalizedString(@"toDoNilError", nil)                                                       delegate:nil
                                              cancelButtonTitle:@"OK"
                                              otherButtonTitles:nil];
        [alert show];
        
        
    }
}
@end