//
//  test.m
//  IOS Learning Plaform
//
//  Created by Rubén Domínguez on 4/9/16.
//  Copyright © 2016 TheAgileMonkeys. All rights reserved.
//

#import "test.h"
#import "TestQuestion.h"
#import <Parse/Parse.h>

@implementation Test

+ (void)getTestQuestionsForUser:(User *)user withCompletion:(void (^)(NSArray *questions, NSError *error))completion
{
    PFQuery *query = [PFQuery queryWithClassName:@"Test_Answer"];
    [query whereKey:@"user" equalTo:user.modelId];
    [query whereKey:@"isCorrect" equalTo:@YES];
    [query selectKeys:@[@"question"]];
    [query findObjectsInBackgroundWithBlock:^(NSArray *success_answers, NSError *error) {
        if (!error) {
            PFObject *answer;
            NSMutableArray *questionsKeys = [NSMutableArray array];
            
            for (answer in success_answers){
                PFObject *cuestion = answer[@"question"];
                [questionsKeys addObject:cuestion.objectId];
            }
            
            PFQuery *query = [PFQuery queryWithClassName:@"Test_Question"];
            [query whereKey:@"objectId" notContainedIn:questionsKeys];
            [query findObjectsInBackgroundWithBlock:^(NSArray *questions, NSError *error){
                if(!error){

                    NSMutableArray *formatted_questions = [NSMutableArray array];
                    
                    for (PFObject *question in questions) {
                        NSDictionary *dic = [question dictionaryWithValuesForKeys:@[@"objectId", @"answer", @"spanish_statement", @"spanish_explanation", @"english_statement", @"english_explanation"]];
                        TestQuestion *new_question = [[TestQuestion alloc] initWithDictionary:dic];
                        [formatted_questions addObject:new_question];
                    }
                    
                    completion(formatted_questions, nil);
                }
                else
                {
                    completion(nil, error);
                }
            }];
        }
        else
        {
            completion(nil, error);
        }
    }];
}

@end
