//
//  ToDo.m
//  IOS Learning Plaform
//
//  Created by Rubén on 18/10/13.
//  Copyright (c) 2013 TheAgileMonkeys. All rights reserved.
//

#import "ToDo.h"


@implementation ToDo

@dynamic date;
@dynamic body;
@dynamic done;
@dynamic parseId;

+ (NSFetchedResultsController *)toDosFetcher
{
    NSManagedObjectContext *moc = [(AppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
    
    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
    // Edit the entity name as appropriate.
    NSEntityDescription *entity = [NSEntityDescription entityForName:@"ToDo" inManagedObjectContext:moc];
    [fetchRequest setEntity:entity];
    
    // Set the batch size to a suitable number.
    [fetchRequest setFetchBatchSize:20];
    
    // Edit the sort key as appropriate.
    NSSortDescriptor *sortDescriptor = [[NSSortDescriptor alloc] initWithKey:@"done" ascending:YES];
    NSSortDescriptor *sortDescriptor2 = [[NSSortDescriptor alloc] initWithKey:@"date" ascending:YES];
    
    NSArray *sortDescriptors = @[sortDescriptor, sortDescriptor2];
    
    [fetchRequest setSortDescriptors:sortDescriptors];
    
    // Edit the section name key path and cache name if appropriate.
    // nil for section name key path means "no sections".
   return [[NSFetchedResultsController alloc] initWithFetchRequest:fetchRequest managedObjectContext:moc sectionNameKeyPath:@"done" cacheName:nil];
}

+ (instancetype)newToDo
{
    NSManagedObjectContext *moc = [(AppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
     NSEntityDescription *entityDescriptor = [NSEntityDescription entityForName:@"ToDo" inManagedObjectContext:moc];
    
    return [[self alloc] initWithEntity:entityDescriptor insertIntoManagedObjectContext:moc];
}

- (void)updateWithBody:(NSString *)body status:(NSNumber *)status date:(NSDate *)date andID:(NSString *)serverId
{
    self.body = body;
    self.done = status;
    self.date = date;
    self.parseId = serverId;
    
    NSManagedObjectContext *moc = [(AppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
    NSError *error;
    [moc save:&error];
}

- (void)updateStatusWith:(NSNumber *)status
{
    NSManagedObjectContext *moc = [(AppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
    self.done = status;
    NSError *error;
    [moc save:&error];
}

- (void)destroyToDoWithCompletionBLock:(void (^)(NSError *error))completion
{
    NSManagedObjectContext *moc = [(AppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
    [moc deleteObject:self];
    NSError *error;
    if (![moc save:&error]) {
        completion(error);
    }
}

@end

