//
//  TutorialViewController.m
//  IOS Learning Plaform
//
//  Created by Rubén Domínguez Falcón on 18/09/13.
//  Copyright (c) 2013 TheAgileMonkeys. All rights reserved.
//

#import "TutorialViewController.h"
#import "VideoPlayerViewController.h"


@interface TutorialViewController ()
@property (weak, nonatomic) IBOutlet UILabel *pageTitleLabel;
@property (weak, nonatomic) IBOutlet UILabel *statusBarBackgroundLabel;
@property (weak, nonatomic) IBOutlet UIButton *beginButton;

@property (weak, nonatomic) IBOutlet UILabel *descriptionVideo2Label;
@property (weak, nonatomic) IBOutlet UILabel *descriptionVideo1Label;
@property (weak, nonatomic) IBOutlet UIView *scrollContentVIew;
@property (weak, nonatomic) IBOutlet UIScrollView *scrollView;

@property (weak, nonatomic) IBOutlet UIImageView *tutorial1placeholderImageView;

@property (weak, nonatomic) IBOutlet UIImageView *tutorial2PlaceholderImageView;
- (IBAction)Begin:(id)sender;

@end

@implementation TutorialViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.statusBarBackgroundLabel.backgroundColor = navbarBackground;
    self.pageTitleLabel.text = NSLocalizedString(@"tutorialPageTitleText", nil);
    self.pageTitleLabel.backgroundColor = navbarBackground;
    self.pageTitleLabel.textColor = [UIColor whiteColor];

    [self.beginButton setTitleColor:navbarBackground forState:UIControlStateNormal];
    [self.beginButton.layer setBorderWidth:1.0f];
    [self.beginButton.layer setBorderColor:navbarBackground.CGColor];

    [self.beginButton setTitle:NSLocalizedString(@"tutorialStartButtonText", nil) forState:UIControlStateNormal];
    
    [self.descriptionVideo1Label setFont:[UIFont fontWithName:@"Aleo-Regular" size:18]];
    [self.descriptionVideo1Label setTextColor:backgroudLabel];
    [self.descriptionVideo2Label setFont:[UIFont fontWithName:@"Aleo-Regular" size:18]];
    [self.descriptionVideo2Label setTextColor:backgroudLabel];
    
    self.descriptionVideo1Label.text = NSLocalizedString(@"Tutorial1Title", nil);
    self.descriptionVideo2Label.text = NSLocalizedString(@"Tutorial2Title", nil);

    
    
    UITapGestureRecognizer *view1 = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(playTutorial1:)];
    
    UITapGestureRecognizer *view2 = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(playTutorial2:)];
    
    self.tutorial1placeholderImageView.userInteractionEnabled = YES;
    [self.tutorial1placeholderImageView addGestureRecognizer:view1];
    
    self.tutorial2PlaceholderImageView.userInteractionEnabled = YES;
    [self.tutorial2PlaceholderImageView addGestureRecognizer:view2];



}

- (void)viewDidLayoutSubviews
{
    [super viewDidLayoutSubviews];
    self.scrollView.scrollEnabled = YES;
    [self.scrollView setContentSize:CGSizeMake(self.scrollView.frame.size.width, self.scrollContentVIew.frame.size.height)];
    
    
}


#pragma IBaction

- (IBAction)Begin:(id)sender {
    [[NSNotificationCenter defaultCenter] postNotificationName:@"TutorialDidEnd" object:nil];
}

- (void) playTutorial1:(UITapGestureRecognizer *)sender{
    [self playVideo:NSLocalizedString(@"tutorial1Path", nil)];
}
- (void) playTutorial2:(UITapGestureRecognizer *)sender{
    [self playVideo:NSLocalizedString(@"tutorial2Path", nil)];

}

#pragma mark private methods
- (void)playVideo:(NSString *)path
{
    VideoPlayerViewController * videoPlayer = [[VideoPlayerViewController alloc] init];
    videoPlayer.delegate = self;
    videoPlayer.video_url = path;
    videoPlayer.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
    [self presentViewController:videoPlayer animated:YES completion:nil];
}

@end
