//
//  User.m
//  IOS Learning Plaform
//
//  Created by Rubén Domínguez on 17/7/16.
//  Copyright © 2016 TheAgileMonkeys. All rights reserved.
//

#import "User.h"
#import "Lesson.h"


@interface User ()


@end

@implementation User

- (instancetype)init
{
    self = [super init];
    
    if (self)
    {
        self.pfObject = [PFObject objectWithClassName:@"Profile"];
    }
    
    return self;
}

- (void)fetchUserInformationWithCompletion:(void (^)(User *currentUser, NSError *error))completion
{
    PFQuery *query = [PFQuery queryWithClassName:@"Profile"];

    [query getObjectInBackgroundWithId:self.modelId block:^(PFObject *profile, NSError *error) {
        
        if (error) {
            completion(nil, error);
        }
        else
        {
            self.pfObject = profile;
            [self updateWithRemoteInformation];
            if (completion) {
                completion(self, nil);
            }
        }
    }];
}

- (void)updateUserInformationWithCompletion:(void (^)(User *currentUser, NSError *error))completion
{
    [self updatePFObjectInformation];
    [self.pfObject saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
        if (error) {
            completion(nil, error);
        }
        else {
            [self updateWithRemoteInformation];
            completion(self, nil);
        }
    }];
}

#pragma mark - Private Method
- (void)updatePFObjectInformation
{
    self.pfObject[@"name"] = self.name;
    self.pfObject[@"occupation"] = self.occupation;
    self.pfObject[@"email"]= self.email;
    self.pfObject[@"birthdate"] = self.birthDate;
    self.pfObject[@"videoAvaliableTime"] = self.videoAvaliableTime;
    self.pfObject[@"organization"] = self.organization;
    self.pfObject[@"gender"] = self.gender;
}

- (void) updateWithRemoteInformation
{
    self.modelId = [self.pfObject objectId];
    self.name = self.pfObject[@"name"];
    self.occupation = self.pfObject[@"occupation"];
    self.email = self.pfObject[@"email"];
    self.birthDate = self.pfObject[@"birthdate"];
    self.videoAvaliableTime = self.pfObject[@"videoAvaliableTime"];
    self.organization = self.pfObject[@"organization"];
    self.gender = self.pfObject[@"gender"];
}

@end
