//
//  VideoPlayerViewController.m
//  IOS Learning Plaform
//
//  Created by Rubén on 15/10/13.
//  Copyright (c) 2013 TheAgileMonkeys. All rights reserved.
//

#import "VideoPlayerViewController.h"

@interface VideoPlayerViewController ()
{MPMoviePlayerController *moviePlayer;}
@end

@implementation VideoPlayerViewController

@synthesize delegate;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(moviePlayBackDidFinish:)
                                                 name:MPMoviePlayerPlaybackDidFinishNotification
                                               object:moviePlayer];
        
    [self playVideo];

}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)playVideo

{
    
    NSString *file = [[NSBundle mainBundle] pathForResource:self.video_url ofType:@"mp4"];
    NSURL *url = [NSURL fileURLWithPath:file];
    
    moviePlayer = [[MPMoviePlayerController alloc] initWithContentURL:url];
    if (moviePlayer) {
        moviePlayer.controlStyle = MPMovieControlStyleFullscreen;
//        moviePlayer.view.transform = CGAffineTransformConcat(moviePlayer.view.transform, CGAffineTransformMakeRotation(M_PI_2));
        moviePlayer.view.frame = CGRectMake(self.view.frame.origin.x,
                                            self.view.frame.origin.y,
                                            self.view.frame.size.height,
                                            self.view.frame.size.width);
        [moviePlayer play];
        [self.view addSubview:moviePlayer.view];
    }

}





- (void) moviePlayBackDidFinish:(NSNotification*)notification {
    MPMoviePlayerController *player = [notification object];
    [[NSNotificationCenter defaultCenter]
     removeObserver:self
     name:MPMoviePlayerPlaybackDidFinishNotification
     object:player];

    if ([player
         respondsToSelector:@selector(setFullscreen:animated:)])
    {
        NSNumber* reason = [[notification userInfo] objectForKey:MPMoviePlayerPlaybackDidFinishReasonUserInfoKey];
        switch ([reason intValue]) {
            case MPMovieFinishReasonUserExited:{
                [moviePlayer.view removeFromSuperview];
                [self dismissViewControllerAnimated:YES completion:^{
                    if ([self.delegate respondsToSelector:@selector(videoFinishCallback)]) {
                        [[self delegate]  videoFinishCallback];
                    }
                }];

                break;
            }
            default:
                break;
        }
    }
    
}

#pragma mark private function

- (BOOL)shouldAutorotate {
    return NO;
}

- (UIInterfaceOrientation)preferredInterfaceOrientationForPresentation
{
    return UIInterfaceOrientationLandscapeRight;
}
- (NSUInteger)supportedInterfaceOrientations {
    return UIInterfaceOrientationMaskLandscape;
}


@end
