//
//  VideosProgressBar.m
//  IOS Learning Plaform
//
//  Created by Rubén on 15/10/13.
//  Copyright (c) 2013 TheAgileMonkeys. All rights reserved.
//

#import "VideosProgressBar.h"
#import "Lesson.h"

@implementation VideosProgressBar

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}


// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    
    NSDate *now = [NSDate date];
    NSArray *lessons = [CourseManager sharedInstance].lessons;
    Lesson *lesson;
    
    // Drawing code
    UIColor* strokeColor = [UIColor colorWithRed: 0 green: 0 blue: 0 alpha: 1];
    NSInteger width = self.frame.size.width/[lessons count];
    int i = 0;

    for (lesson in lessons) {
        
        UIBezierPath* rectangle2Path = [UIBezierPath bezierPathWithRect: CGRectMake(width*i, 6.5, width, 6)];
        NSDate *aux = [lesson.date dateByAddingTimeInterval:timeBetweenVideos];

        if([lesson.date compare:now] == NSOrderedAscending && [aux compare:now ] == NSOrderedDescending){
            if (lesson.done.boolValue){
                [progressBarViewColor setFill];
                UIBezierPath* rectanglePath = [UIBezierPath bezierPathWithRect: CGRectMake (width*i, 6.5, width - 15, 6)];
                [rectanglePath fill];
                [strokeColor setStroke];
                rectanglePath.lineWidth = 0;
                [rectanglePath stroke];
                UIBezierPath* ovalPath = [UIBezierPath bezierPathWithOvalInRect: CGRectMake((width*i) + (width - 15), 2.5, 15, 15)];
                [strokeColor setFill];
                [ovalPath fill];
                [strokeColor setStroke];
                ovalPath.lineWidth = 0;
                [ovalPath stroke];
            }
            else{
                UIBezierPath* ovalPath = [UIBezierPath bezierPathWithOvalInRect: CGRectMake(width*i, 2.5, 15, 15)];
                [strokeColor setFill];
                [ovalPath fill];
                [strokeColor setStroke];
                ovalPath.lineWidth = 0;
                [ovalPath stroke];
                
                [backgroudLabel setFill];
                UIBezierPath* rectanglePath = [UIBezierPath bezierPathWithRect: CGRectMake (15 +(width*i), 6.5, width - 15, 6)];
                [rectanglePath fill];
                [strokeColor setStroke];
                rectanglePath.lineWidth = 0;
                [rectanglePath stroke];

            }
        }
        else{
            
            if (lesson.done.boolValue) {
                [progressBarViewColor setFill];
                [rectangle2Path fill];
                [strokeColor setStroke];
                rectangle2Path.lineWidth = 0;
                [rectangle2Path stroke];
            }
            else{
                if ([aux compare:now] == NSOrderedAscending) {
                    [navbarBackground setFill];
                }
                else{
                    [backgroudLabel setFill];

                }
                [rectangle2Path fill];
                [strokeColor setStroke];
                rectangle2Path.lineWidth = 0;
                [rectangle2Path stroke];
            }
        }
        i++;
    }
}


@end
